#pragma once

#define Panic()						AssertSz( 0, "Panic" )
#define PanicSz( szFmt )			AssertSz( 0, szFmt )
#define Panic1( szFmt, p1 )			Assert1( 0, szFmt, p1 )
#define Panic2( szFmt, p1, p2 )		Assert2( 0, szFmt, p1, p2 )

#define CASSERT( x ) 				typedef int __dummyarray[( x ) ? 1 : -1];

#ifdef DEBUG

void DbgTrace_( char const* pszFormat, ... );
void DbgTrace( char const* pszFormat, ... );
#define Trace_ DbgTrace_
#define Trace DbgTrace

void DbgAssert( char const* pszFileName, int iLine, char const* pszFmt, ... );

#define Assert( f )					do { if( !( f ) ) DbgAssert( __FILE__, __LINE__, "%s", #f ); break; } while( 0 )
#define AssertSz( f, szFmt )		do { if( !( f ) ) DbgAssert( __FILE__, __LINE__, szFmt ); break; } while( 0 )
#define Assert1( f, szFmt, p1 )		do { if( !( f ) ) DbgAssert( __FILE__, __LINE__, szFmt, p1 ); break; } while( 0 )
#define Assert2( f, szFmt, p1, p2 )	do { if( !( f ) ) DbgAssert( __FILE__, __LINE__, szFmt, p1, p2 ); break; } while( 0 )

#else // !DEBUG

#define syntax_safe do {} while( 0 )

inline void DbgTrace( char const*, ... ) {}
#define Trace_ 1 ? (void)0 : DbgTrace
#define Trace 1 ? (void)0 : DbgTrace

#define Assert( fExpr ) syntax_safe
#define AssertSz( fExpr, sz ) syntax_safe
#define Assert1( fExpr, sz, arg1 ) syntax_safe
#define Assert2( fExpr, sz, arg1, arg2 ) syntax_safe

#endif // !DEBUG

