#pragma once

#define MAJ_VER				1
#define MIN_VER				1
#define DOT_VER				0

#define IND_VER2( a, b ) #a "." #b
#define IND_VER3( a, b, c ) #a "." #b "."
#define IND_VER4( a, b, c, d ) #a "." #b "." #c "." #d
#define DOT_VER2( a, b ) IND_VER2( a, b )
#define DOT_VER3( a, b, c ) IND_VER3( a, b, c )
#define DOT_VER4( a, b, c, d ) IND_VER4( a, b, c, d )

#define RC_VER				MAJ_VER, MIN_VER, 0, DOT_VER

#define STR_VER				DOT_VER3( MAJ_VER, MIN_VER, DOT_VER )
#define STR_RC_VER			DOT_VER4( MAJ_VER, MIN_VER, 0, DOT_VER )

// Platform description and copyright.

#if !defined( STR_PLATFORM ) && defined( OS_NT )

#if   defined( _M_IX86 )    || defined( _X86_ )
#define STR_PLATFORM "NT X86"

#elif defined( _M_ALPHA )   || defined( _ALPHA_ )
#define STR_PLATFORM "NT Alpha"

#elif defined( _M_ALPHA64 ) || defined( _AXP64_ )
#define STR_PLATFORM "NT Alpha64"

#elif defined( _M_IA64 )    || defined( _IA64_ )
#define STR_PLATFORM "NT IA64"

#elif defined( _M_AMD64 )   || defined( _AMD64_ )
#define STR_PLATFORM "NT AMD64"
#endif

#define STR_COPYRIGHTASCII "Copyright (C) 2008 Christopher Antos.  All rights reserved."
#define STR_COPYRIGHT_RC "Copyright \xA9 2008 Christopher Antos.  All rights reserved."

#endif // !STR_PLATFORM && OS_NT

#if !defined(STR_PLATFORM)
#error "Must define appropriate platform text (STR_PLATFORM) in version.h"
#endif

